package router_test

import (
	"encoding/json"
	"net/http"
	"net/http/httptest"
	"testing"

	"galaxy/model/rest"

	"galaxy/util"

	"galaxy/game/internal/controller"
	"galaxy/game/internal/router"
	"galaxy/game/internal/router/handler"

	"github.com/google/uuid"
	"github.com/stretchr/testify/assert"
)

func TestGetStatus(t *testing.T) {
	root, cleanup := util.CreateWorkDir(t)
	defer cleanup()

	r := router.SetupRouter(handler.NewDefaultConfigExecutor(func(p *controller.Param) { p.StoragePath = root }))

	payload := generateInitRequest(10)

	w := httptest.NewRecorder()
	req, _ := http.NewRequest("POST", "/api/v1/admin/init", asBody(payload))
	r.ServeHTTP(w, req)

	assert.Equal(t, http.StatusCreated, w.Code, w.Body)
	var initResponse rest.StateResponse
	assert.NoError(t, json.Unmarshal(w.Body.Bytes(), &initResponse))
	assert.NoError(t, uuid.Validate(initResponse.ID.String()))
	assert.NotEqual(t, uuid.Nil, uuid.MustParse(initResponse.ID.String()))

	w = httptest.NewRecorder()
	req, _ = http.NewRequest("GET", "/api/v1/admin/status", nil)
	r.ServeHTTP(w, req)

	assert.Equal(t, http.StatusOK, w.Code, w.Body)
	var stateResponse rest.StateResponse
	assert.NoError(t, json.Unmarshal(w.Body.Bytes(), &stateResponse))
	assert.NoError(t, uuid.Validate(stateResponse.ID.String()))
	assert.Equal(t, initResponse.ID, stateResponse.ID)
	assert.Equal(t, uint(0), stateResponse.Turn)
	assert.Equal(t, uint(0), stateResponse.Stage)
	assert.False(t, stateResponse.Finished)
	assert.Len(t, stateResponse.Players, 10)
	for i := range stateResponse.Players {
		assert.NoError(t, uuid.Validate(stateResponse.Players[i].ID.String()))
		assert.Equal(t, raceName(i), stateResponse.Players[i].RaceName)
		assert.Equal(t, uint(3), stateResponse.Players[i].Planets)
		assert.Equal(t, 2000., stateResponse.Players[i].Population)
		assert.False(t, stateResponse.Players[i].Extinct)
	}
}
